<?php
class ControllerExtensionPaymentPaykeeper extends Controller {
	public function index() {
		$data['button_confirm'] = $this->language->get('button_confirm');

		$this->load->model('checkout/order');

		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

		$payment_parameters = http_build_query(array(
			"orderid"=>$this->session->data['order_id'],
			"clientid"=>$order_info['email'],
			"sum"=>$this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false),
			"phone"=>$order_info['telephone']
		));

		$data['server'] = $this->config->get('paykeeperserver');
		$data['payment_parameters'] = $payment_parameters;
		
		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/extension/payment/paykeeper.tpl')) {
			return $this->load->view($this->config->get('config_template') . '/template/extension/payment/paykeeper.tpl', $data);
		} else {
			return $this->load->view('/extension/payment/paykeeper.tpl', $data);
		}
	}
	public function callback() {

		if ($this->request->server['REQUEST_METHOD'] == 'POST') {
            $this->load->model('checkout/order');

			
			if(isset($this->request->post['id']) && isset($this->request->post['orderid'])){
				$secret_seed = $this->config->get('paykeepersecret');
				$id = $this->request->post['id'];
				$sum = $this->request->post['sum'];
				$clientid = $this->request->post['clientid'];
				$orderid = $this->request->post['orderid'];
				$key = $this->request->post['key'];

				if ($key != md5 ($id . sprintf ("%.2lf", $sum).$clientid.$orderid.$secret_seed))
				{
					echo "Error! Hash mismatch";
					exit;
				}
				
				$order_info = $this->model_checkout_order->getOrder($orderid);
				
				if ($orderid == "")
				{
					
				}
				else
				{
					$this->model_checkout_order->addOrderHistory($orderid, $this->config->get('paykeeper_order_status_id'));
				}
				echo "OK ".md5($id.$secret_seed);
			}
			else echo "OK";
		}
	}
	
	public function gopay() {
		
		$this->load->language('checkout/checkout');
		$this->load->language('extension/payment/paykeeper');
		
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_cart'),
			'href' => $this->url->link('checkout/cart')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('checkout/checkout', '', 'SSL')
		);
		
		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('paykeeper_title'),
			'href' => $this->url->link('extension/payment/paykeeper/gopay', '', 'SSL')
		);

        $data['heading_title'] = $this->language->get('paykeeper_title');
		$this->document->setTitle($data['heading_title']);
		
		$this->load->model('checkout/order');

		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
        
		$data['server'] = $this->config->get('paykeeperserver');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['column_right'] = $this->load->controller('common/column_right');
		$data['content_top'] = $this->load->controller('common/content_top');
		$data['content_bottom'] = $this->load->controller('common/content_bottom');
		$data['footer'] = $this->load->controller('common/footer');
		$data['header'] = $this->load->controller('common/header');

        //CREATE METHOD
        $data['obj'] = $this;

        $data['sum'] = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
        $data['orderid'] = $this->session->data['order_id'];
        $data['clientid'] = $this->session->data['payment_address']['firstname'] . " " . $this->session->data['payment_address']['lastname'];
        $data['client_email'] = $order_info['email'];
        $data['client_phone'] = $order_info['telephone'];
        $data['service_name'] = "";
		$data['secret'] = $this->config->get('paykeepersecret');

        //GENERATE FZ54 CART
        $cart = array();
        $cart_sum = 0;
        $tax = "none";
        $tax_sum = 0;
        $tax_value = 0;

        $cart_data = $this->cart->getProducts();

        foreach ($cart_data as $product) {
            $price = number_format($product['price'], 2, ".", "");
            $quantity = $product['quantity'];
            $sum = number_format($price*$quantity, 2, ".", "");
            $cart_sum += $sum;

            if ( (int)$product["tax_class_id"] != 0) {

                foreach($this->tax->getRates($sum, $product['tax_class_id']) as $td) {
                    $tax_data = $td;
                }
                $tax_value = (int)$tax_data['rate'];

                switch($tax_value) {

                    case 10:
                        $tax = "vat10";
                        $tax_sum = round((float)(($sum/110)*10), 2);
                        break;

                    case 18:
                        $tax = "vat18";
                        $tax_sum = round((float)(($sum/118)*18), 2);
                        break;
                }
            }
            $name = $product["name"];
            $name = str_replace("\n ", "", $name);
            $name = str_replace("\r ", "", $name);
            $name = str_replace(" ", "&nbsp;", $name);
            $cart[] = array(
                "name" => htmlspecialchars($name),
                "price" => $price,
                "quantity" => $quantity,
                "sum" => $sum,
                "tax" => $tax,
                "tax_sum" => number_format($tax_sum, 2, ".", "")
            );
            $tax = "none";
            $tax_sum = 0;
            $tax_value = 0;
        }

        //add shipping service
        if (array_key_exists('shipping_method', $this->session->data)) {
            $shipping_price = $this->session->data['shipping_method']['cost'];
            $shipping_name = $this->session->data['shipping_method']['title'];
            $shipping_name = str_replace("\n ", "", $shipping_name);
            $shipping_name = str_replace("\r ", "", $shipping_name);
            $shipping_name = str_replace(" ", "&nbsp;", $shipping_name);
            $cart[] = array(
                "name" => htmlspecialchars($shipping_name),
                "price" => number_format($shipping_price, 2, ".", ""),
                "quantity" => 1,
                "sum" => number_format($shipping_price, 2, ".", ""),
                "tax" => 'vat18',
                "tax_sum" => round((float)(($shipping_price/118)*18), 2)
            );
        }

        //handle of using discount coupons
        if (array_key_exists("coupon", $this->session->data)) {
            $order_sum = $data['sum'] - $shipping_price;
            if ($cart_sum > $order_sum) {
                $percent = ($cart_sum - $order_sum) / ($cart_sum/100);
                $cart_sum = 0;
                for ($pos=0; $pos<count($cart)-1; $pos++) {
                    $price_diff = $cart[$pos]['price']/100*$percent;
                    $cart[$pos]['price'] -= $price_diff;
                    $cart[$pos]['price'] = number_format($cart[$pos]['price'], 2, ".", "");
                    $cart[$pos]['sum'] = $cart[$pos]['price']*$cart[$pos]['quantity'];
                    $cart[$pos]['sum'] = number_format($cart[$pos]['sum'], 2, ".", "");
                    $cart_sum += $cart[$pos]['sum'];
                    //recalculate taxes
                    switch($pk_cart[$pos]['tax']) {
                        case "vat10":
                            $pk_cart[$pos]['tax_sum'] = round((float)(($pk_cart[$pos]['sum']/110)*10), 2);
                            break;
                        case "vat18":
                            $pk_cart[$pos]['tax_sum'] = round((float)(($pk_cart[$pos]['sum']/118)*18), 2);
                            break;
                    }
                }
            }
        }

        //handle possible precision problem
        $data['precision_error'] = False;
        $total_sum = number_format($data['sum'], 2, ".", "");
        //add shipping sum to cart sum
        if ($shipping_price > 0)
            $cart_sum = $cart_sum+$cart[count($cart)-1]['sum'];
        //DEBUG
        //echo "total: " . $total_sum . " - cart: " . $cart_sum;
        $diff_sum = $cart_sum - $total_sum;
        if (abs($diff_sum) <= 0.019) {
            $data['sum'] = number_format($total_sum+$diff_sum, 2, ".", "");
        }
        else $data['precision_error'] = True;

        $to_hash = number_format ($data['sum'], 2 , '.' , '') .
                                  $data['clientid']           . 
                                  $data['orderid']            .   
                                  $data['service_name']       .   
                                  $data['client_email']       .   
                                  $data['client_phone']       .   
                                  $data['secret'];

        $data['sign'] = hash ('sha256' , $to_hash);

        //debug info
        //echo "<pre>";
        //$data['debug_info'] = var_dump($cart);
        //$data['debug_info'] = var_dump($this->session->data);
        //$data['debug_info'] = var_dump($order_info);
        //var_dump($this->session->data);
        //echo "</pre>";

        $cart = json_encode($cart);
        $data['cart'] = $cart;

		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/extension/payment/paykeeper_iframe.tpl')) {
			$this->response->setOutput($this->load->view($this->config->get('config_template') . '/template/extension/payment/paykeeper_iframe.tpl', $data));
		} else {
			$this->response->setOutput($this->load->view('extension/payment/paykeeper_iframe.tpl', $data));
		}
	}
	public function success() {
		
		$this->load->language('checkout/checkout');
		$this->load->language('extension/payment/paykeeper');

        //clear cart
        $this->cart->clear();
		
		$data['heading_title'] = $this->language->get('paykeeper_title');
		
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_cart'),
			'href' => $this->url->link('checkout/cart')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('checkout/checkout', '', 'SSL')
		);
		
		$data['message'] = $this->language->get('paykeeper_success');

		$this->document->setTitle($data['message']);
		
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['column_right'] = $this->load->controller('common/column_right');
		$data['content_top'] = $this->load->controller('common/content_top');
		$data['content_bottom'] = $this->load->controller('common/content_bottom');
		$data['footer'] = $this->load->controller('common/footer');
		$data['header'] = $this->load->controller('common/header');
		
		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/extension/payment/paykeeper_feedback.tpl')) {
			$this->response->setOutput($this->load->view($this->config->get('config_template') . '/template/extension/payment/paykeeper_feedback.tpl', $data));
		} else {
			$this->response->setOutput($this->load->view('extension/payment/paykeeper_feedback.tpl', $data));
		}
	}
	public function failed() {
		
		$this->load->language('checkout/checkout');
		$this->load->language('extension/payment/paykeeper');
		
		$data['heading_title'] = $this->language->get('paykeeper_title');
		
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_cart'),
			'href' => $this->url->link('checkout/cart')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('checkout/checkout', '', 'SSL')
		);
		
		$data['message'] = $this->language->get('paykeeper_failed');

		$this->document->setTitle($data['message']);
		
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['column_right'] = $this->load->controller('common/column_right');
		$data['content_top'] = $this->load->controller('common/content_top');
		$data['content_bottom'] = $this->load->controller('common/content_bottom');
		$data['footer'] = $this->load->controller('common/footer');
		$data['header'] = $this->load->controller('common/header');
		
		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/extension/payment/paykeeper_feedback.tpl')) {
			$this->response->setOutput($this->load->view($this->config->get('config_template') . '/template/extension/payment/paykeeper_feedback.tpl', $data));
		} else {
			$this->response->setOutput($this->load->view('extension/payment/paykeeper_feedback.tpl', $data));
		}
	}

    public function confirm() {
            $this->load->model('checkout/order');
            $this->model_checkout_order->addOrderHistory($this->session->data['order_id'], 1);
        }
}
